#ifndef SBK_KCOLUMNRESIZERWRAPPER_H
#define SBK_KCOLUMNRESIZERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kcolumnresizer.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class KColumnResizerWrapper : public KColumnResizer
{
public:
    KColumnResizerWrapper(::QObject * parent = nullptr);
    KColumnResizerWrapper(const KColumnResizerWrapper &) = delete;
    KColumnResizerWrapper& operator=(const KColumnResizerWrapper &) = delete;
    KColumnResizerWrapper(KColumnResizerWrapper &&) = delete;
    KColumnResizerWrapper& operator=(KColumnResizerWrapper &&) = delete;
    ~KColumnResizerWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * arg__1, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_KCOLUMNRESIZERWRAPPER_H
