#ifndef SBK_KLINEEDITURLDROPEVENTFILTERWRAPPER_H
#define SBK_KLINEEDITURLDROPEVENTFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <klineediturldropeventfilter.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class KLineEditUrlDropEventFilterWrapper : public KLineEditUrlDropEventFilter
{
public:
    KLineEditUrlDropEventFilterWrapper(::QObject * parent = nullptr);
    KLineEditUrlDropEventFilterWrapper(const KLineEditUrlDropEventFilterWrapper &) = delete;
    KLineEditUrlDropEventFilterWrapper& operator=(const KLineEditUrlDropEventFilterWrapper &) = delete;
    KLineEditUrlDropEventFilterWrapper(KLineEditUrlDropEventFilterWrapper &&) = delete;
    KLineEditUrlDropEventFilterWrapper& operator=(KLineEditUrlDropEventFilterWrapper &&) = delete;
    ~KLineEditUrlDropEventFilterWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * object, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_KLINEEDITURLDROPEVENTFILTERWRAPPER_H
