#ifndef SBK_KTOGGLEFULLSCREENACTIONWRAPPER_H
#define SBK_KTOGGLEFULLSCREENACTIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <ktogglefullscreenaction.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class KToggleFullScreenActionWrapper : public KToggleFullScreenAction
{
public:
    KToggleFullScreenActionWrapper(::QObject * parent);
    KToggleFullScreenActionWrapper(::QWidget * window, ::QObject * parent);
    KToggleFullScreenActionWrapper(const KToggleFullScreenActionWrapper &) = delete;
    KToggleFullScreenActionWrapper& operator=(const KToggleFullScreenActionWrapper &) = delete;
    KToggleFullScreenActionWrapper(KToggleFullScreenActionWrapper &&) = delete;
    KToggleFullScreenActionWrapper& operator=(KToggleFullScreenActionWrapper &&) = delete;
    ~KToggleFullScreenActionWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * object, ::QEvent * event) override;
    void slotToggled(bool checked) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_KTOGGLEFULLSCREENACTIONWRAPPER_H
