#ifndef SBK_KTWOFINGERTAPRECOGNIZERWRAPPER_H
#define SBK_KTWOFINGERTAPRECOGNIZERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <ktwofingertap.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class KTwoFingerTapRecognizerWrapper : public KTwoFingerTapRecognizer
{
public:
    KTwoFingerTapRecognizerWrapper();
    KTwoFingerTapRecognizerWrapper(const KTwoFingerTapRecognizerWrapper &) = delete;
    KTwoFingerTapRecognizerWrapper& operator=(const KTwoFingerTapRecognizerWrapper &) = delete;
    KTwoFingerTapRecognizerWrapper(KTwoFingerTapRecognizerWrapper &&) = delete;
    KTwoFingerTapRecognizerWrapper& operator=(KTwoFingerTapRecognizerWrapper &&) = delete;
    ~KTwoFingerTapRecognizerWrapper() override;

    ::QGesture * create(::QObject * target) override;
    static ::QGesture * sbk_o_create(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * target);
    ::QFlags<QGestureRecognizer::ResultFlag> recognize(::QGesture * gesture, ::QObject * watched, ::QEvent * event) override;
    static ::QFlags<QGestureRecognizer::ResultFlag> sbk_o_recognize(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QGesture * gesture, ::QObject * watched, ::QEvent * event);
    void reset(::QGesture * state) override;
    static void sbk_o_reset(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QGesture * state);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_KTWOFINGERTAPRECOGNIZERWRAPPER_H
